program BadReceive;

uses
  Forms,
  SysUtils,
  Windows,
  Graphics,
  Classes,
  IniFiles,
  dialogs,
  scrn in 'scrn.pas' {SaverScreen},
  config in 'config.pas' {Konfiguration};

{$E SCR}
{$R *.RES}

var DemoWnd:hwnd;
  //MyRect:TRect;//Als Ersatz fr Screen
  //ScrWidth,ScrHeight:Integer;
  MyCanvas:TCanvas;

begin
Application.Initialize;

//Trackbar hier noch nicht aufrufbar, deshalb hier einige ihrer fixen Startwerte
Kontrastmaximum_Trackbar:=20;
Kontrastmittelwert:=Kontrastmaximum_Trackbar div 2;
Kontrast_Trackbar:=Kontrastmittelwert;
Helligkeitsmaximum_Trackbar:=20;
Helligkeitsmittelwert:=Helligkeitsmaximum_Trackbar div 2;
Helligkeit_Trackbar:=Helligkeitsmittelwert;
Saettigungsmaximum_Trackbar:=20;

IniFile:=TIniFile.Create(ChangeFileExt(ParamStr(0),'.ini'));
//Einstellungen aus ini laden oder Vorgabewerte
if Fileexists(ChangeFileExt(ParamStr(0),'.ini')) then
  begin //ini-Datei existiert schon, ldt die Einstellungen
  Kontrast_Trackbar:=IniFile.ReadInteger('Parameter','Kontrast_Trackbar',Kontrast_Trackbar);
  Helligkeit_Trackbar:=IniFile.ReadInteger('Parameter','Helligkeit_Trackbar',Helligkeit_Trackbar);
  Saettigung_Trackbar:=IniFile.ReadInteger('Parameter','Saettigung_Trackbar',Saettigung_Trackbar);
  Farbmischung:=IniFile.ReadInteger('Parameter','Farbmischung',Farbmischung);
  Pixelabstand:=IniFile.ReadInteger('Parameter','Pixelabstand',Pixelabstand);
  Pixelform_Quadrat:=IniFile.ReadBool('Parameter','Pixelform_Quadrat',Pixelform_Quadrat)
  end
else
  begin //ini-Datei existiert noch nicht, Vorgabeeinstellungen
  Kontrast_Trackbar:=Kontrastmittelwert;
  Helligkeit_Trackbar:=Helligkeitsmittelwert;
  Saettigung_Trackbar:=0;
  Farbmischung:=0;
  Pixelabstand:=2
  end;

Pixelgroesse:=(3*Pixelabstand) div 2;
Kontrastverhaeltnis:=Kontrast_Trackbar/Kontrastmaximum_Trackbar;
Kontrastinvertverhaeltnis:=(Kontrastmaximum_Trackbar-Kontrast_Trackbar)/Kontrastmaximum_Trackbar;
Helligkeitsverhaeltnis:=Helligkeit_Trackbar/Helligkeitsmaximum_Trackbar;
Helligkeitsinvertverhaeltnis:=(Helligkeitsmaximum_Trackbar-Helligkeit_Trackbar)/(Helligkeitsmaximum_Trackbar);
Saettigung:=(240*Saettigung_Trackbar) div Saettigungsmaximum_Trackbar;
Saettigungsinvertverhaeltnis:=(Saettigungsmaximum_Trackbar-Saettigung_Trackbar)/Saettigungsmaximum_Trackbar;

if {Copy(UpperCase(ParamStr(1)),1,2)}UpperCase(ParamStr(1))='/P' then
  begin
  DemoWnd:=StrToInt(UpperCase(ParamStr(2)));
  //while not IsWindowVisible(DemoWnd) do Application.ProcessMessages;
  while IsWindow(DemoWnd) and not IsWindowVisible(DemoWnd) do Application.ProcessMessages;//Elternfenster z.B. dann nicht vorhanden, wenn BSS aus der Kommandozeile mit /P gestartet wird

  //GetWindowRect(DemoWnd,MyRect);
  //ScrWidth:=succ(MyRect.Right-MyRect.Left);
  //ScrHeight:=succ(MyRect.Bottom-MyRect.Top);
  //MyRect:=Rect(0,0,pred(Screen.Width),pred(Screen.Height){ScrWidth-1,ScrHeight-1});//Wozu? Wird nirgendwo verwendet!

  MyCanvas:=TCanvas.Create;
  MyCanvas.Handle:=GetDC(DemoWnd);
  x_reduziert:=succ({ScrWidth}Screen.Width div Pixelabstand);//succ({Screen}Form2.Width div SpinEdit1.Value);
  y_reduziert:=succ({ScrHeight}Screen.Height div Pixelabstand);//succ({Screen}Form2.Height div SpinEdit1.Value);
  while IsWindowVisible(DemoWnd) do
    //begin
    Ausgabe(MyCanvas,Screen.Width,Screen.Height);
    //MyCanvas.Pixels[random(ScrWidth),random(ScrHeight)]:=random($FFFFFF+1);
    //Application.ProcessMessages
    //end;

  MyCanvas.Free
  end
else
  if Copy(UpperCase(ParamStr(1)),1,2)='/C' then //hier geht es leider nicht ohne copy
    begin
    Application.CreateForm(TKonfiguration,Konfiguration);//ohne den Block und ohne das Semikolon hier am Ende ist der Quelltext ab Delphi 3 nicht compilierbar
    end
  else Application.CreateForm(TSaverScreen,SaverScreen);

Application.Run;
IniFile.Free
end.
