unit config;

interface

uses
  Windows,
  //Messages,
  //SysUtils,
  //Classes,//ab Delphi 3
  //Graphics,
  //Controls,//ab Delphi 3
  Forms,
  //Dialogs,
  StdCtrls,
  Spin,
  ExtCtrls,
  ComCtrls,
  IniFiles, Controls, Classes;

type
  TKonfiguration = class(TForm)
    Button1: TButton;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    TrackBar2: TTrackBar;
    Label2: TLabel;
    TrackBar3: TTrackBar;
    Label3: TLabel;
    RadioGroup1: TRadioGroup;
    Label6: TLabel;
    SpinEdit1: TSpinEdit;
    RadioGroup2: TRadioGroup;
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Konfiguration: TKonfiguration;
  IniFile:TIniFile;

implementation

{$R *.DFM}

uses scrn;

procedure TKonfiguration.TrackBar1Change(Sender: TObject);
begin
Kontrast_Trackbar:=TrackBar1.Position
end;

procedure TKonfiguration.TrackBar2Change(Sender: TObject);
begin
Helligkeit_Trackbar:=Trackbar2.Position
end;

procedure TKonfiguration.TrackBar3Change(Sender: TObject);
begin
Saettigung_Trackbar:=TrackBar3.Position;
RadioGroup1.Enabled:=TrackBar3.Position<>TrackBar3.Min
end;

procedure TKonfiguration.RadioGroup1Click(Sender: TObject);
begin
Farbmischung:=RadioGroup1.Itemindex;
RadioGroup1.Enabled:=TrackBar3.Position<>TrackBar3.Min
end;

procedure TKonfiguration.SpinEdit1Change(Sender: TObject);
begin
Pixelabstand:=SpinEdit1.Value;
Pixelgroesse:=(3*Pixelabstand) div 2
end;

procedure TKonfiguration.FormCreate(Sender: TObject);
begin
SpinEdit1.MaxValue:=screen.Width;
Trackbar1.Position:=Kontrast_Trackbar;
Trackbar1.Max:=Kontrastmaximum_Trackbar;
//Trackbar1.SelStart:=Kontrastmittelwert;
//Trackbar1.SelEnd:=Kontrastmittelwert;
Trackbar2.Position:=Helligkeit_Trackbar;
Trackbar2.Max:=Helligkeitsmaximum_Trackbar;
//Trackbar2.SelStart:=Helligkeitsmittelwert;
//Trackbar2.SelEnd:=Helligkeitsmittelwert;
Trackbar3.Position:=Saettigung_Trackbar;
Trackbar3.Max:=Saettigungsmaximum_Trackbar;
RadioGroup1.Itemindex:=Farbmischung;
SpinEdit1.Value:=Pixelabstand;
RadioGroup1.Enabled:=TrackBar3.Position<>TrackBar3.Min;
if Pixelform_Quadrat
then RadioGroup2.ItemIndex:=0
else RadioGroup2.ItemIndex:=1
end;

procedure TKonfiguration.Button1Click(Sender: TObject);
begin
IniFile.WriteInteger('Parameter','Kontrast_Trackbar',Kontrast_Trackbar);
IniFile.WriteInteger('Parameter','Helligkeit_Trackbar',Helligkeit_Trackbar);
IniFile.WriteInteger('Parameter','Saettigung_Trackbar',Saettigung_Trackbar);
IniFile.WriteInteger('Parameter','Farbmischung',Farbmischung);
IniFile.WriteInteger('Parameter','Pixelabstand',Pixelabstand);
IniFile.WriteBool('Parameter','Pixelform_Quadrat',Pixelform_Quadrat);
Close
end;

procedure TKonfiguration.RadioGroup2Click(Sender: TObject);
begin
Pixelform_quadrat:=RadioGroup2.ItemIndex=0
end;

end.
